#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/syscall.h>

#define WINS 5
#define RANGE 1000
#define TIMES 6

struct GAME {
	char username[32];
	int play_count;
	int wins;
};

void guess_number(struct GAME* game)
{
	game->play_count--;
	int l = 1, r = RANGE, v = rand() % RANGE + 1, g;
	int times = TIMES;
	while(times > 0) {
		printf("You can guess %d times, value between %d and %d: ", times, l, r);
		scanf("%d", &g);

		if(g == v) {
			game->wins++;
			puts("You win!");
			return;
		}

		if(g < v) {
			l = g + 1;
		} else if (g > v) {
			r = g - 1;
		}

		puts("Wrong.");
		times--;
	}
}

int main()
{
	struct GAME game = { 0 };
	game.play_count = 3;
	game.wins = 0;

	int seed;
	syscall(SYS_getrandom, &seed, 4, 0);
	srand(seed);

	setbuf(stdin, NULL);
	setbuf(stdout, NULL);

	printf("Tell me what's your name pls: ");
	scanf("%s", game.username);

	while(game.play_count > 0) {
		printf("You can play %d times and you have to win (%d/%d) times to get flag\n", game.play_count, game.wins, WINS);
		guess_number(&game);

		if(game.wins == WINS) {
			puts("You win! Now you can have your flag.");
			system("cat flag");
			exit(0);
		}
	}

	puts("Sorry, no more chance...");
}
